
# LiionDB

LiionDB is an interactive database of DFN-type battery model parameters that will accompany the upcoming review manuscript: Parameterising Continuum-Level Li-ion Battery Models. 

If you use LiionDB in your work, please cite our paper at: doi.org



---
### 🔗 Link to LiionDB GUI
You may access the early version of LiionDB  at the link below:

**[https://ndrewwang.github.io/liiondb/](https://ndrewwang.github.io/liiondb/)**
LiionDB was created using [streamlit.io](https://streamlit.io/)

---
### 🐍 Using LiionDB with Python

If you would like to interact with the parameter database with programmatically, check out these Colab python notebooks here:

1. [Example LiionDB queries](https://colab.research.google.com/github/ndrewwang/liiondb/blob/main/python%20notebooks/1_Example_Queries.ipynb)
2. [Plotting parameter comparisons](https://colab.research.google.com/github/ndrewwang/liiondb/blob/main/python%20notebooks/2_Parameter_Plotter.ipynb)

---
### Acknowledgements

 - Supported by the [Multi-Scale Modelling](https://www.faraday.ac.uk/research/lithium-ion/battery-system-modelling/) project within [The Faraday Institution](https://www.faraday.ac.uk/)
  
